package knightminer.inspirations.library.recipe.cauldron.contenttype;

import knightminer.inspirations.library.recipe.cauldron.contents.EmptyCauldronContents;
import knightminer.inspirations.library.recipe.cauldron.contents.ICauldronContents;
import net.minecraft.network.PacketBuffer;

import javax.annotation.Nullable;

/**
 * Content type for the empty contents, exists to prevent errors from the empty contents having no type
 */
public class EmptyContentType extends CauldronContentType<EmptyCauldronContents, Void> {
  public EmptyContentType() {
    super(EmptyCauldronContents.class, voidIn -> EmptyCauldronContents.INSTANCE, c -> null);
  }

  @Override
  public String getName(Void value) {
    return "empty";
  }

  @Nullable
  @Override
  public Void getEntry(String name) {
    return null;
  }

  @Override
  public EmptyCauldronContents read(PacketBuffer buffer) {
    return EmptyCauldronContents.INSTANCE;
  }

  @Override
  public void write(ICauldronContents contents, PacketBuffer buffer) {}
}
